package test;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URI;
import java.net.URL;

// Hinweis: Klasse kann genutzt und darf/soll angepasst werden
public class Execute {
  public static String executeGet(String path) throws IOException {
    System.out.println("path: " + path);
    HttpURLConnection conn = null;
    try {
    //URL url = new URL("http://localhost:8080/" +path);
      URL url = URI.create("http://localhost:8080/" +path).toURL();
      conn = (HttpURLConnection) url.openConnection();
      conn.setRequestMethod("GET");
      conn.setRequestProperty("Accept", "application/json");
      if (conn.getResponseCode() != 200) { // 200 OK
        throw new RuntimeException("" + conn.getResponseCode());
      }
      InputStreamReader in = new InputStreamReader(conn.getInputStream());
      BufferedReader br = new BufferedReader(in);
      String text = ""; // besser StringBuffer
      String output;
      while ((output = br.readLine()) != null) {
        text += output;
      }
      return text;
    } finally {
      if (conn !=null) {
        conn.disconnect();
      }
    }
  }
  
  //basiert auf https://www.baeldung.com/httpurlconnection-post
  public static String executePost(String path, String content) throws IOException {
    HttpURLConnection conn = null;
    try {
    //URL url = new URL("http://localhost:8080/" +path);
      URL url = URI.create("http://localhost:8080/" +path).toURL();
      conn = (HttpURLConnection) url.openConnection();
      conn.setRequestMethod("POST");
      conn.setRequestProperty("Content-Type", "application/json; utf-8");
      conn.setRequestProperty("Accept", "application/json");
      conn.setDoOutput(true);
      OutputStream os = conn.getOutputStream(); 
      byte[] input = content.getBytes("utf-8");
      os.write(input, 0, input.length); 
      
      if (conn.getResponseCode() != 201) { // 201 created
        throw new RuntimeException("" + conn.getResponseCode());
      }
      return conn.getHeaderField("Location");
    } finally {
      if (conn !=null) {
        conn.disconnect();
      }
    }
  }
  
  // Refactor executePut und executePost sehr aehnlich
  public static String executePut(String path, String content) throws IOException {
    HttpURLConnection conn = null;
    try {
    //URL url = new URL("http://localhost:8080/" +path);
      URL url = URI.create("http://localhost:8080/" +path).toURL();
      conn = (HttpURLConnection) url.openConnection();
      conn.setRequestMethod("PUT");
      conn.setRequestProperty("Content-Type", "application/json; utf-8");
      conn.setRequestProperty("Accept", "application/json");
      conn.setDoOutput(true);
      OutputStream os = conn.getOutputStream(); 
      byte[] input = content.getBytes("utf-8");
      os.write(input, 0, input.length); 
      
      if (conn.getResponseCode() != 200) { // 200 OK
        throw new RuntimeException("" + conn.getResponseCode());
      }
//      InputStreamReader in = new InputStreamReader(conn.getInputStream());
//      BufferedReader br = new BufferedReader(in);
//      String text = "";
//      String output;
//      while ((output = br.readLine()) != null) {
//        text += output;
//      }
      return conn.getHeaderField("Location");
      //return text;
    } finally {
      if (conn !=null) {
        conn.disconnect();
      }
    }
  }
}
